module business {
	class healthwatcher.business..*;
	friend healthwatcher.aspects.distribution.HWServerDistribution;
	friend healthwatcher.aspects.persistence.HWDataCollection;

	expose :
		healthwatcher.aspects.distribution.HWServerDistribution.facadeMain();
	expose :
		healthwatcher.aspects.persistence.HWPersistence.newFacade();
	expose :
		healthwatcher.aspects.persistence.HWTransactionManagement.transactionalMethods();

	expose :
		healthwatcher.aspects.concurrency.HWManagedSynchronization.synchronizationPoints(healthwatcher.model.employee.Employee);
}

module data {
	class healthwatcher.data..*;
	friend healthwatcher.aspects.concurrency.HWLocalSynchronization;

	expose :
		healthwatcher.aspects.concurrency.HWTimestamp.insertComplaint(healthwatcher.model.complaint.Complaint);
	expose :
		healthwatcher.aspects.concurrency.HWTimestamp.searchComplaint(healthwatcher.model.complaint.Complaint);
	expose :
		healthwatcher.aspects.concurrency.HWTimestamp.updateComplaint(healthwatcher.model.complaint.Complaint, healthwatcher.data.rdb.ComplaintRepositoryRDB);
}

module model {
	class healthwatcher.model..*;
	friend healthwatcher.aspects.concurrency.HWTimestamp;
}

module view {
	class healthwatcher.view..*;
	friend healthwatcher.aspects.patterns.ServletCommanding;

	expose :
		healthwatcher.aspects.exceptionHandling.HWDistributionExceptionHandler.servletGet(javax.servlet.http.HttpServletResponse);
	expose :
		healthwatcher.aspects.exceptionHandling.HWPersistenceExceptionHandler.servletGet(javax.servlet.http.HttpServletResponse);
	expose :
		healthwatcher.aspects.exceptionHandling.HWTransactionExceptionHandler.servletGet(javax.servlet.http.HttpServletResponse);

	expose :
		healthwatcher.aspects.distribution.HWClientDistribution.facadeMethods();

	expose :
		healthwatcher.aspects.patterns.ServletCommanding.servletInit();
}

module lib {
	class lib..*;

	expose :
		call(* lib.distribution.rmi.MethodExecutor.invoke(..));
	
	expose :
		healthwatcher.aspects.distribution.HWClientDistribution.iteratorDskMethods();

	expose :
		healthwatcher.aspects.persistence.HWTransactionManagement.persistenceMethods();

	expose :
		call(* lib.util.HTMLCode.*(..));

	expose :
		call(lib.distribution.rmi.IteratorRMISourceAdapter.new(..));

	expose :
		call(lib.distribution.rmi.IteratorRMITargetAdapter.new(..));

	expose :
		call(* lib.exceptions.*.*(..));

	expose :
		healthwatcher.aspects.patterns.ServletCommanding.commandTrigger(lib.patterns.CommandInvoker);
}

module CommandProtocolITD {
	friend lib.patterns.CommandProtocol;
	open lib;
	open view;
}
